//+--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                                                                           DateTimeInstance.mqh |
//|                                                                                                                                                                            hoz |
//|                                                                                                                                                                                |
//+--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
#property copyright "hoz"
#property link      ""

//+================================================================================================================================================================================+
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//|                                                              СТРУКТУРА-ЭКЗЕМПЛЯР, ПРЕДСТАВЛЯЮЩАЯ СОБОЙ ДАТУ И ВРЕМЯ                                                            |
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+================================================================================================================================================================================+
struct DateTimeInstance {
  MqlDateTime m_dtStructure;
  //---- Конструкторы
  DateTimeInstance(datetime dt);
  DateTimeInstance(datetime dt, int hour, int minute);
  //--- Переопределение операторов
  void operator=(DateTimeInstance& dt);
  bool operator==(DateTimeInstance& dt);
  bool operator!=(DateTimeInstance& dt);
  bool operator<(DateTimeInstance& dt);
  bool operator>(DateTimeInstance& dt);
  bool operator<=(DateTimeInstance& dt);
  bool operator>=(DateTimeInstance& dt);
};
//==================================================================================================================================================================================
// Конструкторы структуры. =========================================================================================================================================================
DateTimeInstance :: DateTimeInstance(datetime dt) {
  TimeToStruct(dt, m_dtStructure);
}
//---
DateTimeInstance :: DateTimeInstance(datetime dt,     // Значение типа datetime
                                     int hour,        // Количество часов
                                     int minute) {    // Количество минут
//---
  TimeToStruct(dt, m_dtStructure);
  m_dtStructure.hour = hour;
  m_dtStructure.min = minute;
}
//==================================================================================================================================================================================
// Переопределение оператора `=`. ==================================================================================================================================================
void DateTimeInstance :: operator=(DateTimeInstance& dt) {
//---
  m_dtStructure.year = dt.m_dtStructure.year;
  m_dtStructure.mon = dt.m_dtStructure.mon;
  m_dtStructure.day = dt.m_dtStructure.day;
  m_dtStructure.hour = dt.m_dtStructure.hour;
  m_dtStructure.min = dt.m_dtStructure.min;
}
//==================================================================================================================================================================================
// Переопределение оператора `==`. =================================================================================================================================================
bool DateTimeInstance :: operator==(DateTimeInstance& dt) {
//---
  if (m_dtStructure.year != dt.m_dtStructure.year)
    return false;
  if (m_dtStructure.mon != dt.m_dtStructure.mon)
    return false;
  if (m_dtStructure.day != dt.m_dtStructure.day)
    return false;
  if (m_dtStructure.hour != dt.m_dtStructure.hour)
    return false;
  if (m_dtStructure.min != dt.m_dtStructure.min)
    return false;
//---
  return true;
}
//==================================================================================================================================================================================
// Переопределение оператора `!=`. =================================================================================================================================================
bool DateTimeInstance :: operator!=(DateTimeInstance& dt) {
//---
  if (m_dtStructure.year != dt.m_dtStructure.year)
    return true;
  if (m_dtStructure.mon != dt.m_dtStructure.mon)
    return true;
  if (m_dtStructure.day != dt.m_dtStructure.day)
    return true;
  if (m_dtStructure.hour != dt.m_dtStructure.hour)
    return true;
  if (m_dtStructure.min != dt.m_dtStructure.min)
    return true;
//---
  return false;
}
//==================================================================================================================================================================================
// Переопределение оператора `<`. ==================================================================================================================================================
bool DateTimeInstance :: operator<(DateTimeInstance& dt) {
//---
  if (StructToTime(m_dtStructure) < StructToTime(dt.m_dtStructure))
    return true;
//---
  return false;
}
//==================================================================================================================================================================================
// Переопределение оператора `>`. ==================================================================================================================================================
bool DateTimeInstance :: operator>(DateTimeInstance& dt) {
//---
  if (StructToTime(m_dtStructure) > StructToTime(dt.m_dtStructure))
    return true;
//---
  return false;
}
//==================================================================================================================================================================================
// Переопределение оператора `<=`. ==================================================================================================================================================
bool DateTimeInstance :: operator<=(DateTimeInstance& dt) {
//---
  if (StructToTime(m_dtStructure) <= StructToTime(dt.m_dtStructure))
    return true;
//---
  return false;
}
//==================================================================================================================================================================================
// Переопределение оператора `>`. ==================================================================================================================================================
bool DateTimeInstance :: operator>=(DateTimeInstance& dt) {
//---
  if (StructToTime(m_dtStructure) >= StructToTime(dt.m_dtStructure))
    return true;
//---
  return false;
}
